import numpy

class Marcador :
	K = numpy.matrix( [ [1000.0,    0.0, -300.0],
	                  [   0.0,   1000.0, -200.0],
	                  [   0.0,      0.0,   -1.0] ] )

	def __init__( self ) :
		self.v = numpy.zeros( (4,3) ) 
		self.img = numpy.zeros( (4,2) ) 


	def Crea( self, l ) :
		self.v[0][0] = l 
		self.v[0][1] = 0.0
		self.v[0][2] = 0.0

		self.v[1][0] = 0
		self.v[1][1] = l 
		self.v[1][2] = 0.0

		self.v[2][0] = -l
		self.v[2][1] = 0.0 
		self.v[2][2] = 0.0

		self.v[3][0] = 0.0
		self.v[3][1] = -l
		self.v[3][2] = 0.0

	def dibuja3D( self ) :
		print self.v[0][0], self.v[0][1], self.v[0][2]
		print self.v[1][0], self.v[1][1], self.v[1][2]
		print self.v[2][0], self.v[2][1], self.v[2][2]
		print self.v[3][0], self.v[3][1], self.v[3][2]
		print self.v[0][0], self.v[0][1], self.v[0][2]
		print

	def dibuja2D( self ) :
		print self.img[0][0], self.img[0][1]
		print self.img[1][0], self.img[1][1]
		print self.img[2][0], self.img[2][1]
		print self.img[3][0], self.img[3][1]
		print self.img[0][0], self.img[0][1]
		print

	def Proyecta( self, vo, vc, va ) :
		v2 = vc - vo
		k = numpy.linalg.norm( v2 )
		vz = v2 / k

		v3 = numpy.cross( va, vz )
		vx = v3/numpy.linalg.norm(v3)

		vy = numpy.cross( vz, vx )

		R = numpy.matrix ( [ vx, vy, vz ] )
		print R

		vp = numpy.matrix( [ [0.0], [0.0], [0.0]] )
		i = 0
		while i<4 :
			vr = self.v[i]
			#
			# Aplicamos vp = T(-c) vr
			# 
			vp[0] = vr[0] - vc[0]
			vp[1] = vr[1] - vc[1]
			vp[2] = vr[2] - vc[2]

			v3 = R * vp
			v2 = Marcador.K * v3

			self.img[i][0] = v2[0]/v2[2]
			self.img[i][1] = v2[1]/v2[2]

			i += 1

