# encoding: utf-8
import numpy
import sys
import marcador

if len( sys.argv ) != 10 :
	# o punto a donde ve la cámara
	# c centro de la cámara
	# a vector de arriba
	print "Args: ox oy oz cx cy cz ax ay az"
	sys.exit(1)

vo = numpy.array( [ float(sys.argv[1]), float(sys.argv[2]), float(sys.argv[3]) ] )
vc = numpy.array( [ float(sys.argv[4]), float(sys.argv[5]), float(sys.argv[6]) ] )
va = numpy.array( [ float(sys.argv[7]), float(sys.argv[8]), float(sys.argv[9]) ] )

marcador1 = marcador.Marcador( )
marcador2 = marcador.Marcador( )

marcador1.Crea( 1.0 )
marcador2.Crea( 0.5 )

marcador1.Proyecta( vo, vc, va )
marcador2.Proyecta( vo, vc, va )
 
marcador1.dibuja2D( )
marcador2.dibuja2D( )
