# Graficar la ecuacin implcita de la cnica:
#  ax^2 + bxy + cy^2 + dx + ey + f = 0
# 
set term x11

a = 258.258138 
b = 100.049714 
Xc = 300.000003
Yc = 176.719546
ang = 0.000000 


ang = ang*pi/180
x(t) = a*cos(t)
y(t) = b*sin(t)

s = sin( ang )
c = cos( ang )
xp(t) = c*x(t) - s*y(t) + Xc
yp(t) = s*x(t) + c*y(t) + Yc

set size ratio -1
set xrange [0:600]
set yrange [0:400]
set multiplot
unset key
set parametric
plot xp(t), yp(t)

a = 126.383794 
b = 47.943210 
Xc = 300.000003
Yc = 194.413666
ang = 0.000000 

ang = ang*pi/180
s = sin( ang )
c = cos( ang )
plot xp(t), yp(t)

plot 'p' w lp lw 2

plot 'centro' w p ps 3

unset multiplot
pause -1

